﻿import es
import playerlib
import gamethread
import cfglib
import popuplib
import langlib
import random
import psyco
import popuplib
psyco.full()

info = es.AddonInfo()
info.name      = 'MedicalKit'
info.version   = '2.0'
info.url = 'http://addons.eventscripts.com/addons/view/medkit'
info.basename  = 'medkit'
info.author    = 'Kana'
 
es.ServerVar(info.name, info.version).makepublic()

# Global Variables(DON'T TOUCH)
active = 1
players = {}
buyPopup = None
givePopup = None
kitPopup = None


# MedKit Commands
use_cmd = ["!use"]
give_cmd = ["!give"]
menu_cmd = ["!kit"]
info_cmd = ["!info", "!help"]


# Language Creator
lang = langlib.Strings(es.getAddonPath("medkit") + "/strings.ini")


# Medkit Config Creator
config = cfglib.AddonCFG(es.getAddonPath("medkit") + "/settings.cfg")
 
config.text("******************************")
config.text("MEDKIT V2.1 SETTINGS")
config.text("******************************")
 
health  = config.cvar("medkit_health",  25, "Life given to players.")
buy     = config.cvar("medkit_buy",     0, "1 = Players can buy at the round start. 0 = Free kits for all at round start")
price  = config.cvar("medkit_price",  200, "MedKit price if medkit_buy is enabled.")
delay 	= config.cvar("medkit_delay",   3, "Time to heal")
scream 	= config.cvar("medkit_scream",   0, "Enable/Disable Auto Call for help")
scream_life 	= config.cvar("medkit_scream_life",   50, "If medkit_scream is enable set the minimum life for the player to start calling for help")
sounds 	= config.cvar("medkit_sounds",  1, "1 = Enable custom sounds. 0 = Disable custom sounds")
 
config.write()	


# MedKit Sounds
sounds = [
		  'vo/npc/male01/health01.wav',
		  'vo/npc/male01/health02.wav',
		  'vo/npc/male01/health03.wav', 
		  'vo/npc/male01/health04.wav',
		  'vo/npc/male01/health05.wav'
		 ]
		 
scream_sounds = [
				"vo/ravenholm/monk_helpme01.wav",
				"vo/ravenholm/monk_helpme02.wav",
				"vo/ravenholm/monk_helpme03.wav",
				"vo/ravenholm/monk_helpme04.wav",
				"vo/ravenholm/monk_helpme05.wav",
				"vo/streetwar/sniper/male01/c17_09_help01.wav",
				"vo/streetwar/sniper/male01/c17_09_help02.wav"
				]

def add(userid):

	if not players.has_key(userid):
		players[userid] = 0
		
		
		
def player_hurt(event_var):
	if scream and scream_life:
		player = playerlib.getPlayer(int(event_var["userid"]))
		if player.team == 3: team = "#ct"
		elif player.team == 2: team = "#t"
		if len(playerlib.getPlayerList('#alive,%s' % team)) > 1 and player.health <= scream_life:
			es.emitsound("player", player.userid, random.choice(scream_sounds), 0.6)
			
		
		
	
def player_activate(event_var):

	add(int(event_var['userid']))
	
	
def player_disconnect(event_var):

	del players[int(event_var['userid'])]
	

def player_spawn(event_var):

	userid = int(event_var['userid'])
	
	closePopups(userid)
	
	if not players.has_key(userid):
		add(userid)
		
	if buy:
		if int(event_var["es_userteam"]) in [2, 3]:
			players[userid] = 0
			gamethread.delayed(0.5, buyPopup.send, userid)
	else:
		players[userid] = 1
		es.tell(userid, '#multi', lang("kitgained"))
		
def player_death(event_var):
	closePopups(int(event_var["userid"]))

		
def filter1(userid, text, teamonly):
	
	text = text.strip('"')
	if text in use_cmd:
		check(userid, "use")
		return (0,0,0)
	if text in give_cmd:
		check(userid, "give")
		return (0,0,0)
	if text in menu_cmd:
		check(userid, "kit")
		return (0,0,0)
	if text in info_cmd:
		es.menu(0, userid, '%s\n \n%s (%s)\n%s (%s)\n%s (%s)' % (lang("commandsinfo"), use_cmd[0], lang("useinfo"), give_cmd[0], lang("giveinfo"), menu_cmd[0], lang("maininfo")))
	return (userid, text, teamonly)
		
		
def filter2(userid, args):

	if args[0].lower() in use_cmd:
		check(userid, "use")
	if args[0].lower() in give_cmd:
		check(userid, "give")
	if args[0].lower() in menu_cmd:
		check(userid, "kit")
		return (0,0,0)
	if args[0].lower() in info_cmd:
		es.menu(0, userid, '%s\n \n%s (%s)\n%s (%s)' % (lang("commandsinfo"), use_cmd, lang("useinfo"), give_cmd, lang("giveinfo")))
	if args[0].lower() in [use_cmd, give_cmd, info_cmd]: 
		return False
	return True
	

def check(userid, a):

	if active:
		player = playerlib.getPlayer(userid)
		if player.isdead: 
			return es.tell(userid, '#multi', lang("Dead"))
			
		if players[userid] == 0:
			return es.tell(userid, '#multi', lang("NoKits"))
			
		if a == "use":
			heal(player)
		elif a == "give":
			give(player)
		elif a == "kit":
			closePopups(userid)
			kitPopup.send(userid)
			
def heal(player):

	if player.health >= 100:
		return es.tell(player.userid, '#multi', lang("FullLife"))
	
	players[player.userid] -= 1
	es.tell(player.userid, '#multi', lang("kitused"))
	gamethread.delayedname(delay, player.userid, sethealth, player)
	
def sethealth(player):
	if not active:
		return
		
	if not es.exists('userid', player.userid):
		return
		
	if player.health + health >= 100:
		player.health = 100
	else:
		player.health += health
	
	es.tell(player.userid, '#multi', lang('Healed'))
	if sounds:
		es.playsound(player.userid, 'buttons/blip2.wav', 0.6)
			
def give(player):

	global givePopup
	givePopup = popuplib.easymenu('give',None,select)
	givePopup.settitle(lang("choosefriend"))
	count = 0
	
	for target in playerlib.getPlayerList('#alive'):
		if not target.userid == player.userid and target.team == player.team and target.userid in player.getNearPlayers(240):
			givePopup.addoption(target.userid, target.name)
			count += 1
	if count > 0:
		closePopups(player.userid)
		givePopup.send(player.userid)
	else:
		es.tell(player.userid, '#multi', lang("notargets"))
			
def select(userid, choice, name):

	if not es.exists('userid', choice):
		return es.tell(userid, '#multi', lang("invalidtarget"))
	player = playerlib.getPlayer(userid)
	target = playerlib.getPlayer(choice)
	if players[userid] > 0:
		if not target.isdead:
			if choice in player.getNearPlayers(240):
				tokens = {}
				tokens['target'] = target.name
				tokens['player'] = player.name
				es.tell(userid, '#multi', lang("kitgiven", tokens, target.get("lang")))
				es.tell(choice, '#multi', lang("kitreceived", tokens, player.get("lang")))
				players[userid] -= 1
				players[choice] += 1
				
				if sounds:
					es.emitsound('player', userid, random.choice(sounds), 0.6)
			else:
				es.tell(userid, '#multi', lang("notargets"))
		else:
			es.tell(userid, '#multi', lang("targetdead"))
	else:
		es.tell(userid, '#multi', lang("NoKits"))
		
def buykit(userid, choice, name):

	if choice == 1:
		player = playerlib.getPlayer(userid)
		if player.get("cash") >= price:
			if es.getplayerprop(userid, "CCSPlayer.m_bInBuyZone"):
				player.cash -= price
				players[userid] += 1
				es.tell(userid, '#multi', lang("buykit"))
			else:
				es.tell(userid, '#multi', lang("buyzone"))
				buyPopup.send(userid)
		else:
			es.tell(userid, '#multi', lang("nocash"))
		
def kitselect(userid, choice, name):

	if choice == 1:
		es.cexec(userid, use_cmd[0])
	elif choice == 2:
		es.cexec(userid, give_cmd[0])
	
	
def closePopups(userid):
	popuplib.close("buy", userid)
	popuplib.close("kit", userid)
	if popuplib.exists("give") and popuplib.isqueued("give", userid):
		popuplib.close("give", userid)
			
			
def round_start(event_var):

	global active
	active = 1
	
	gamethread.cancelDelayed("spawnhelp")
	gamethread.delayedname(8, "spawnhelp", es.msg, ('#multi', lang("spawnhelp")))
		

def round_end(event_var):

	global active
	active = 0
	for userid in es.getUseridList():
		closePopups(userid)
		
def load():

	global buyPopup
	buyPopup = popuplib.easymenu('buy',None,buykit)
	buyPopup.settitle(lang("Buy"))
	buyPopup.addoption(1, lang("Yes"))
	buyPopup.addoption(2, lang("No"))
	
	global kitPopup
	kitPopup = popuplib.easymenu('kit',None,kitselect)
	kitPopup.settitle(lang("commandsinfo"))
	kitPopup.addoption(1, lang("Use"))
	kitPopup.addoption(2, lang("Give"))
	

	for userid in es.getUseridList():
		add(userid)
	
	es.addons.registerSayFilter(filter1)
	es.addons.registerClientCommandFilter(filter2)
	
	config.execute()	
		
def unload():

	players.clear()
	
	for userid in es.getUseridList():
		closePopups(userid)
		
	if popuplib.exists("give"): givePopup.delete()
	buyPopup.delete()
	kitPopup.delete()
	
	gamethread.cancelDelayed("spawnhelp")
		
	es.addons.unregisterSayFilter(filter1)
	es.addons.unregisterClientCommandFilter(filter2)